## pthreadpool 0.0~git20200423.6acde9c

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.5 FATAL_ERROR)

# ---[ Project
PROJECT(pthreadpool C CXX)

# ---[ Options.
SET(PTHREADPOOL_LIBRARY_TYPE "default" CACHE STRING "Type of library (shared, static, or default) to build")
SET_PROPERTY(CACHE PTHREADPOOL_LIBRARY_TYPE PROPERTY STRINGS default static shared)
OPTION(PTHREADPOOL_ALLOW_DEPRECATED_API "Enable deprecated API functions" ON)
SET(PTHREADPOOL_SYNC_PRIMITIVE "default" CACHE STRING "Synchronization primitive (condvar, futex, gcd, event, or default) for worker threads")
SET_PROPERTY(CACHE PTHREADPOOL_SYNC_PRIMITIVE PROPERTY STRINGS default condvar futex gcd event)
IF("${CMAKE_SOURCE_DIR}" STREQUAL "${PROJECT_SOURCE_DIR}")
  OPTION(PTHREADPOOL_BUILD_TESTS "Build pthreadpool unit tests" ON)
  OPTION(PTHREADPOOL_BUILD_BENCHMARKS "Build pthreadpool micro-benchmarks" ON)
ELSE()
  SET(PTHREADPOOL_BUILD_TESTS OFF CACHE BOOL "Build pthreadpool unit tests")
  SET(PTHREADPOOL_BUILD_BENCHMARKS OFF CACHE BOOL "Build pthreadpool micro-benchmarks")
ENDIF()

# ---[ CMake options
INCLUDE(GNUInstallDirs)

IF(PTHREADPOOL_BUILD_TESTS)
  ENABLE_TESTING()
ENDIF()

MACRO(PTHREADPOOL_TARGET_ENABLE_CXX11 target)
  SET_TARGET_PROPERTIES(${target} PROPERTIES
    CXX_STANDARD 11
    CXX_EXTENSIONS NO)
ENDMACRO()

# ---[ Download deps
IF(NOT DEFINED FXDIV_SOURCE_DIR)
  MESSAGE(STATUS "Downloading FXdiv to ${CMAKE_BINARY_DIR}/FXdiv-source (define FXDIV_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadFXdiv.cmake "${CMAKE_BINARY_DIR}/FXdiv-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/FXdiv-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/FXdiv-download")
  SET(FXDIV_SOURCE_DIR "${CMAKE_BINARY_DIR}/FXdiv-source" CACHE STRING "FXdiv source directory")
ENDIF()

IF(PTHREADPOOL_BUILD_TESTS AND NOT DEFINED GOOGLETEST_SOURCE_DIR)
  MESSAGE(STATUS "Downloading Google Test to ${CMAKE_BINARY_DIR}/googletest-source (define GOOGLETEST_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadGoogleTest.cmake "${CMAKE_BINARY_DIR}/googletest-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googletest-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googletest-download")
  SET(GOOGLETEST_SOURCE_DIR "${CMAKE_BINARY_DIR}/googletest-source" CACHE STRING "Google Test source directory")
ENDIF()

IF(PTHREADPOOL_BUILD_BENCHMARKS AND NOT DEFINED GOOGLEBENCHMARK_SOURCE_DIR)
  MESSAGE(STATUS "Downloading Google Benchmark to ${CMAKE_BINARY_DIR}/googlebenchmark-source (define GOOGLEBENCHMARK_SOURCE_DIR to avoid it)")
  CONFIGURE_FILE(cmake/DownloadGoogleBenchmark.cmake "${CMAKE_BINARY_DIR}/googlebenchmark-download/CMakeLists.txt")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googlebenchmark-download")
  EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
    WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googlebenchmark-download")
  SET(GOOGLEBENCHMARK_SOURCE_DIR "${CMAKE_BINARY_DIR}/googlebenchmark-source" CACHE STRING "Google Benchmark source directory")
ENDIF()

# ---[ pthreadpool library
IF(PTHREADPOOL_ALLOW_DEPRECATED_API)
  SET(PTHREADPOOL_SRCS src/legacy-api.c)
ENDIF()
IF(EMSCRIPTEN)
  LIST(APPEND PTHREADPOOL_SRCS src/shim.c)
ELSE()
  LIST(APPEND PTHREADPOOL_SRCS src/portable-api.c src/memory.c)
  IF(APPLE AND (PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "default" OR PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "gcd"))
    LIST(APPEND PTHREADPOOL_SRCS src/gcd.c)
  ELSEIF(WIN32 AND (PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "default" OR PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "event"))
    LIST(APPEND PTHREADPOOL_SRCS src/windows.c)
  ELSE()
    LIST(APPEND PTHREADPOOL_SRCS src/pthreads.c)
  ENDIF()
ENDIF()

ADD_LIBRARY(pthreadpool_interface INTERFACE)
TARGET_INCLUDE_DIRECTORIES(pthreadpool_interface INTERFACE include)
IF(NOT PTHREADPOOL_ALLOW_DEPRECATED_API)
  TARGET_COMPILE_DEFINITIONS(pthreadpool_interface INTERFACE PTHREADPOOL_NO_DEPRECATED_API=1)
ENDIF()
INSTALL(FILES include/pthreadpool.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

IF(PTHREADPOOL_LIBRARY_TYPE STREQUAL "default")
  ADD_LIBRARY(pthreadpool ${PTHREADPOOL_SRCS})
ELSEIF(PTHREADPOOL_LIBRARY_TYPE STREQUAL "shared")
  ADD_LIBRARY(pthreadpool SHARED ${PTHREADPOOL_SRCS})
ELSEIF(PTHREADPOOL_LIBRARY_TYPE STREQUAL "static")
  ADD_LIBRARY(pthreadpool STATIC ${PTHREADPOOL_SRCS})
ELSE()
  MESSAGE(FATAL_ERROR "Unsupported library type ${PTHREADPOOL_LIBRARY_TYPE}")
ENDIF()

IF(PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "condvar")
  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FUTEX=0)
  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_GCD=0)
  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_EVENT=0)
ELSEIF(PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "futex")
  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FUTEX=1)
  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_GCD=0)
  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_EVENT=0)
ELSEIF(PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "gcd")
  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FUTEX=0)
  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_GCD=1)
  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_EVENT=0)
ELSEIF(PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "event")
  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FUTEX=0)
  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_GCD=0)
  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_EVENT=1)
ELSEIF(NOT PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "default")
  MESSAGE(FATAL_ERROR "Unsupported synchronization primitive ${PTHREADPOOL_SYNC_PRIMITIVE}")
ENDIF()

SET_TARGET_PROPERTIES(pthreadpool PROPERTIES
  C_STANDARD 11
  C_EXTENSIONS NO)
TARGET_LINK_LIBRARIES(pthreadpool PUBLIC pthreadpool_interface)
TARGET_INCLUDE_DIRECTORIES(pthreadpool PRIVATE src)
IF(NOT CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  SET(CMAKE_THREAD_PREFER_PTHREAD TRUE)
  IF(NOT CMAKE_GENERATOR STREQUAL "Xcode")
    FIND_PACKAGE(Threads REQUIRED)
  ENDIF()
  IF(CMAKE_USE_PTHREADS_INIT)
    IF(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "Android")
      TARGET_COMPILE_OPTIONS(pthreadpool PUBLIC -pthread)
    ENDIF()
  ENDIF()
  TARGET_LINK_LIBRARIES(pthreadpool PUBLIC ${CMAKE_THREAD_LIBS_INIT})
ENDIF()
IF(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE _GNU_SOURCE=1)
ENDIF()

# ---[ Configure FXdiv
IF(NOT TARGET fxdiv)
  SET(FXDIV_BUILD_TESTS OFF CACHE BOOL "")
  SET(FXDIV_BUILD_BENCHMARKS OFF CACHE BOOL "")
  ADD_SUBDIRECTORY(
    "${FXDIV_SOURCE_DIR}"
    "${CMAKE_BINARY_DIR}/FXdiv")
ENDIF()
TARGET_LINK_LIBRARIES(pthreadpool PRIVATE fxdiv)

INSTALL(TARGETS pthreadpool
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

IF(PTHREADPOOL_BUILD_TESTS)
  # ---[ Build google test
  IF(NOT TARGET gtest)
    SET(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
    ADD_SUBDIRECTORY(
      "${GOOGLETEST_SOURCE_DIR}"
      "${CMAKE_BINARY_DIR}/googletest")
  ENDIF()

  ADD_EXECUTABLE(pthreadpool-test test/pthreadpool.cc)
  SET_TARGET_PROPERTIES(pthreadpool-test PROPERTIES
    CXX_STANDARD 11
    CXX_EXTENSIONS NO)
  TARGET_LINK_LIBRARIES(pthreadpool-test pthreadpool gtest gtest_main)
  ADD_TEST(pthreadpool pthreadpool-test)
ENDIF()

IF(PTHREADPOOL_BUILD_BENCHMARKS)
  # ---[ Build google benchmark
  IF(NOT TARGET benchmark)
    SET(BENCHMARK_ENABLE_TESTING OFF CACHE BOOL "")
    ADD_SUBDIRECTORY(
      "${GOOGLEBENCHMARK_SOURCE_DIR}"
      "${CMAKE_BINARY_DIR}/googlebenchmark")
  ENDIF()

  ADD_EXECUTABLE(latency-bench bench/latency.cc)
  SET_TARGET_PROPERTIES(latency-bench PROPERTIES
    CXX_STANDARD 11
    CXX_EXTENSIONS NO)
  TARGET_LINK_LIBRARIES(latency-bench pthreadpool benchmark)

  ADD_EXECUTABLE(throughput-bench bench/throughput.cc)
  SET_TARGET_PROPERTIES(throughput-bench PROPERTIES
    CXX_STANDARD 11
    CXX_EXTENSIONS NO)
  TARGET_LINK_LIBRARIES(throughput-bench pthreadpool benchmark)
ENDIF()

=== debian/changelog ===
pthreadpool (0.0~git20200423.6acde9c-2) unstable; urgency=medium

  * Add the missing build dependencies.
  * Apply wrap-and-sort.
  * Add symbols control file for libpthreadpool0.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Wed, 29 Apr 2020 08:54:40 +0800

pthreadpool (0.0~git20200423.6acde9c-1) experimental; urgency=medium

  * Initial release. (Closes: #958655)

 -- Mo Zhou <lumin@debian.org>  Fri, 24 Apr 2020 16:02:29 +0800

=== debian/control ===
Source: pthreadpool
Section: libdevel
Homepage: https://github.com/Maratyszcza/pthreadpool
Priority: optional
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/pthreadpool.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/pthreadpool
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               googletest,
               libbenchmark-dev,
               libcpuinfo-dev,
               libfxdiv-dev
Rules-Requires-Root: no

Package: libpthreadpool-dev
Architecture: any
Depends: libpthreadpool0 (= ${binary:Version}), ${misc:Depends}
Description: pthread-based thread pool for C/C++
 pthreadpool is a portable and efficient thread pool implementation. It provides
 similar functionality to #pragma omp parallel for, but with additional
 features.
 .
 This package contains the development files.

Package: libpthreadpool0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: pthread-based thread pool for C/C++
 pthreadpool is a portable and efficient thread pool implementation. It provides
 similar functionality to #pragma omp parallel for, but with additional
 features.
 .
 This package contains the shared object.

## pthreadpool 0.0~git20200615.029c886

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,11 @@
 OPTION(PTHREADPOOL_ALLOW_DEPRECATED_API "Enable deprecated API functions" ON)
 SET(PTHREADPOOL_SYNC_PRIMITIVE "default" CACHE STRING "Synchronization primitive (condvar, futex, gcd, event, or default) for worker threads")
 SET_PROPERTY(CACHE PTHREADPOOL_SYNC_PRIMITIVE PROPERTY STRINGS default condvar futex gcd event)
+IF(CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|AMD64|x86(_64)?)$")
+  OPTION(PTHREADPOOL_ENABLE_FASTPATH "Enable fast path using atomic decrement instead of atomic compare-and-swap" ON)
+ELSE()
+  OPTION(PTHREADPOOL_ENABLE_FASTPATH "Enable fast path using atomic decrement instead of atomic compare-and-swap" OFF)
+ENDIF()
 IF("${CMAKE_SOURCE_DIR}" STREQUAL "${PROJECT_SOURCE_DIR}")
   OPTION(PTHREADPOOL_BUILD_TESTS "Build pthreadpool unit tests" ON)
   OPTION(PTHREADPOOL_BUILD_BENCHMARKS "Build pthreadpool micro-benchmarks" ON)
@@ -71,10 +76,13 @@
   LIST(APPEND PTHREADPOOL_SRCS src/portable-api.c src/memory.c)
   IF(APPLE AND (PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "default" OR PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "gcd"))
     LIST(APPEND PTHREADPOOL_SRCS src/gcd.c)
-  ELSEIF(WIN32 AND (PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "default" OR PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "event"))
+  ELSEIF(CMAKE_SYSTEM_NAME MATCHES "^(Windows|CYGWIN|MSYS)$" AND (PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "default" OR PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "event"))
     LIST(APPEND PTHREADPOOL_SRCS src/windows.c)
   ELSE()
     LIST(APPEND PTHREADPOOL_SRCS src/pthreads.c)
+  ENDIF()
+  IF(PTHREADPOOL_ENABLE_FASTPATH)
+    LIST(APPEND PTHREADPOOL_SRCS src/fastpath.c)
   ENDIF()
 ENDIF()
 
@@ -114,6 +122,11 @@
 ELSEIF(NOT PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "default")
   MESSAGE(FATAL_ERROR "Unsupported synchronization primitive ${PTHREADPOOL_SYNC_PRIMITIVE}")
 ENDIF()
+IF(PTHREADPOOL_ENABLE_FASTPATH)
+  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_ENABLE_FASTPATH=1)
+ELSE()
+  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_ENABLE_FASTPATH=0)
+ENDIF()
 
 SET_TARGET_PROPERTIES(pthreadpool PROPERTIES
   C_STANDARD 11

=== debian/changelog ===
pthreadpool (0.0~git20200615.029c886-2) unstable; urgency=medium

  * Change maintainer into Deep Learning Team <debian-ai@l.d.o>.
  * Please pin to this upstream snapshot for PyTorch 1.7.0.

 -- Mo Zhou <lumin@debian.org>  Mon, 02 Nov 2020 11:03:57 +0800

pthreadpool (0.0~git20200615.029c886-1) unstable; urgency=medium

  * New upstream version 0.0~git20200615.029c886
  * Refresh symbols control file (+ several new symbols).
  * Bump debhelper compat level to 13.
  * Add d/not-installed.

 -- Mo Zhou <lumin@debian.org>  Wed, 02 Sep 2020 13:44:18 +0800

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/deeplearning-team/pthreadpool.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/pthreadpool
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                googletest,
                libbenchmark-dev,
                libcpuinfo-dev,

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure -- -DGOOGLETEST_SOURCE_DIR=/usr/src/googletest -DPTHREADPOOL_LIBRARY_TYPE=shared

## pthreadpool 0.0~git20201005.fa75e65

=== CMakeLists.txt ===
--- 
+++ 
@@ -123,9 +123,9 @@
   MESSAGE(FATAL_ERROR "Unsupported synchronization primitive ${PTHREADPOOL_SYNC_PRIMITIVE}")
 ENDIF()
 IF(PTHREADPOOL_ENABLE_FASTPATH)
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_ENABLE_FASTPATH=1)
-ELSE()
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_ENABLE_FASTPATH=0)
+  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FASTPATH=1)
+ELSE()
+  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FASTPATH=0)
 ENDIF()
 
 SET_TARGET_PROPERTIES(pthreadpool PROPERTIES
@@ -178,6 +178,13 @@
     CXX_EXTENSIONS NO)
   TARGET_LINK_LIBRARIES(pthreadpool-test pthreadpool gtest gtest_main)
   ADD_TEST(pthreadpool pthreadpool-test)
+
+  ADD_EXECUTABLE(pthreadpool-cxx-test test/pthreadpool-cxx.cc)
+  SET_TARGET_PROPERTIES(pthreadpool-cxx-test PROPERTIES
+    CXX_STANDARD 11
+    CXX_EXTENSIONS NO)
+  TARGET_LINK_LIBRARIES(pthreadpool-cxx-test pthreadpool gtest gtest_main)
+  ADD_TEST(pthreadpool-cxx pthreadpool-cxx-test)
 ENDIF()
 
 IF(PTHREADPOOL_BUILD_BENCHMARKS)

=== debian/changelog ===
pthreadpool (0.0~git20201005.fa75e65-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Thu, 02 Sep 2021 02:07:37 +0000

pthreadpool (0.0~git20201005.fa75e65-1) experimental; urgency=medium

  * New upstream version 0.0~git20201005.fa75e65
    Please pin to this snapshot for PyTorch/v1.8.1
  * Refresh existint patches.
  * Refresh symbols control file.

 -- Mo Zhou <lumin@debian.org>  Thu, 20 May 2021 11:43:45 +0800

## pthreadpool 0.0~git20210507.1787867

=== debian/changelog ===
pthreadpool (0.0~git20210507.1787867-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints. + libpthreadpool0: Add Multi-Arch: same.

  [ Mo Zhou ]
  * Bump Standards-Version to 4.6.2 (no change).

 -- Mo Zhou <lumin@debian.org>  Fri, 01 Sep 2023 21:41:04 -0400

pthreadpool (0.0~git20210507.1787867-1) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sat, 25 Jun 2022 20:05:43 -0700

pthreadpool (0.0~git20210507.1787867-1~exp1) experimental; urgency=medium

  * New upstream version 0.0~git20210507.1787867
    This snapshot should be fine for PyTorch/v1.12.X
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Jun 2022 22:44:16 -0700

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libdevel
 Homepage: https://github.com/Maratyszcza/pthreadpool
 Priority: optional
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/deeplearning-team/pthreadpool.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/pthreadpool
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -28,6 +28,7 @@
 Package: libpthreadpool0
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: same
 Description: pthread-based thread pool for C/C++
  pthreadpool is a portable and efficient thread pool implementation. It provides
  similar functionality to #pragma omp parallel for, but with additional

## pthreadpool 0.0~git20240616.560c60d

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 3.5 FATAL_ERROR)
 
 # ---[ Project
-PROJECT(pthreadpool C CXX)
+PROJECT(pthreadpool C)
 
 # ---[ Options.
 SET(PTHREADPOOL_LIBRARY_TYPE "default" CACHE STRING "Type of library (shared, static, or default) to build")
@@ -24,6 +24,10 @@
 
 # ---[ CMake options
 INCLUDE(GNUInstallDirs)
+
+IF(PTHREADPOOL_BUILD_TESTS OR PTHREADPOOL_BUILD_BENCHMARKS)
+  ENABLE_LANGUAGE(CXX)
+ENDIF()
 
 IF(PTHREADPOOL_BUILD_TESTS)
   ENABLE_TESTING()

=== debian/changelog ===
pthreadpool (0.0~git20240616.560c60d-1) unstable; urgency=medium

  * Team upload.
  * d/patches: refresh, rename and add DEP3 header
  * d/control: bump std-ver to 4.7.0.1 (no changes required)
  * d/rules: enable all hardening

 -- Shengqi Chen <harry-chen@outlook.com>  Wed, 04 Sep 2024 19:45:20 +0800

pthreadpool (0.0~git20240616.560c60d-1~exp1) experimental; urgency=medium

  * New upstream version 0.0~git20240616.560c60d
    + This snapshot should be fine for PyTorch/v2.3.X
  * Refresh symbols control file.
  * Make short description different for packages.
  * Upload to experimental
  * Upload to experimental

 -- Mo Zhou <harry-chen@outlook.com>  Wed, 04 Sep 2024 19:37:32 +0800

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libdevel
 Homepage: https://github.com/Maratyszcza/pthreadpool
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0.1
 Vcs-Git: https://salsa.debian.org/deeplearning-team/pthreadpool.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/pthreadpool
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -18,7 +18,7 @@
 Package: libpthreadpool-dev
 Architecture: any
 Depends: libpthreadpool0 (= ${binary:Version}), ${misc:Depends}
-Description: pthread-based thread pool for C/C++
+Description: pthread-based thread pool for C/C++ (development)
  pthreadpool is a portable and efficient thread pool implementation. It provides
  similar functionality to #pragma omp parallel for, but with additional
  features.
@@ -29,7 +29,7 @@
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Multi-Arch: same
-Description: pthread-based thread pool for C/C++
+Description: pthread-based thread pool for C/C++ (shared object)
  pthreadpool is a portable and efficient thread pool implementation. It provides
  similar functionality to #pragma omp parallel for, but with additional
  features.

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,7 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
 %:
 	dh $@ -Scmake

## pthreadpool 0.0~git20251020.0e6ca13

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,51 @@
+# Copyright (c) 2017 Facebook Inc.
+# Copyright (c) 2015-2017 Georgia Institute of Technology
+# All rights reserved.
+#
+# Copyright 2019 Google LLC
+#
+# This source code is licensed under the BSD-style license found in the
+# LICENSE file in the root directory of this source tree.
+
 CMAKE_MINIMUM_REQUIRED(VERSION 3.5 FATAL_ERROR)
 
 # ---[ Project
 PROJECT(pthreadpool C)
+
+# --[ Use ccache if available
+FIND_PROGRAM(CCACHE_BINARY "ccache")
+IF(CCACHE_BINARY)
+  MESSAGE(STATUS "Using ccache: ${CCACHE_BINARY}")
+  SET(CMAKE_CXX_COMPILER_LAUNCHER "${CCACHE_BINARY}" CACHE STRING "CXX compiler launcher" FORCE)
+  SET(CMAKE_C_COMPILER_LAUNCHER "${CCACHE_BINARY}" CACHE STRING "C compiler launcher" FORCE)
+  IF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG}")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO}")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_DEBUG_INIT "${CMAKE_C_FLAGS_DEBU_INITG}")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_DEBUG_INIT "${CMAKE_CXX_FLAGS_DEBUG_INIT}")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_RELWITHDEBINFO_INIT "${CMAKE_C_FLAGS_RELWITHDEBINFO_INIT}")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_RELWITHDEBINFO_INIT "${CMAKE_CXX_FLAGS_RELWITHDEBINFO_INIT}")
+  ENDIF()
+ENDIF()
+
+# ---[ Language options.
+SET(CMAKE_C_STANDARD 11)
+SET(CMAKE_C_EXTENSIONS NO)
+SET(CMAKE_CXX_STANDARD 11)
+SET(CMAKE_CXX_EXTENSIONS NO)
+IF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
+  STRING(APPEND CMAKE_C_FLAGS " /experimental:c11atomics")
+  STRING(APPEND CMAKE_CXX_FLAGS " /experimental:c11atomics")
+ENDIF()
 
 # ---[ Options.
 SET(PTHREADPOOL_LIBRARY_TYPE "default" CACHE STRING "Type of library (shared, static, or default) to build")
 SET_PROPERTY(CACHE PTHREADPOOL_LIBRARY_TYPE PROPERTY STRINGS default static shared)
 OPTION(PTHREADPOOL_ALLOW_DEPRECATED_API "Enable deprecated API functions" ON)
-SET(PTHREADPOOL_SYNC_PRIMITIVE "default" CACHE STRING "Synchronization primitive (condvar, futex, gcd, event, or default) for worker threads")
-SET_PROPERTY(CACHE PTHREADPOOL_SYNC_PRIMITIVE PROPERTY STRINGS default condvar futex gcd event)
+SET(PTHREADPOOL_SYNC_PRIMITIVE "default" CACHE STRING "Synchronization primitive (condvar, futex, or default) for worker threads")
+SET_PROPERTY(CACHE PTHREADPOOL_SYNC_PRIMITIVE PROPERTY STRINGS default condvar futex)
 IF(CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|AMD64|x86(_64)?)$")
   OPTION(PTHREADPOOL_ENABLE_FASTPATH "Enable fast path using atomic decrement instead of atomic compare-and-swap" ON)
 ELSE()
@@ -32,12 +69,6 @@
 IF(PTHREADPOOL_BUILD_TESTS)
   ENABLE_TESTING()
 ENDIF()
-
-MACRO(PTHREADPOOL_TARGET_ENABLE_CXX11 target)
-  SET_TARGET_PROPERTIES(${target} PROPERTIES
-    CXX_STANDARD 11
-    CXX_EXTENSIONS NO)
-ENDMACRO()
 
 # ---[ Download deps
 IF(NOT DEFINED FXDIV_SOURCE_DIR)
@@ -77,14 +108,7 @@
 IF(EMSCRIPTEN)
   LIST(APPEND PTHREADPOOL_SRCS src/shim.c)
 ELSE()
-  LIST(APPEND PTHREADPOOL_SRCS src/portable-api.c src/memory.c)
-  IF(APPLE AND (PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "default" OR PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "gcd"))
-    LIST(APPEND PTHREADPOOL_SRCS src/gcd.c)
-  ELSEIF(CMAKE_SYSTEM_NAME MATCHES "^(Windows|CYGWIN|MSYS)$" AND (PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "default" OR PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "event"))
-    LIST(APPEND PTHREADPOOL_SRCS src/windows.c)
-  ELSE()
-    LIST(APPEND PTHREADPOOL_SRCS src/pthreads.c)
-  ENDIF()
+  LIST(APPEND PTHREADPOOL_SRCS src/portable-api.c src/memory.c src/pthreads.c)
   IF(PTHREADPOOL_ENABLE_FASTPATH)
     LIST(APPEND PTHREADPOOL_SRCS src/fastpath.c)
   ENDIF()
@@ -110,19 +134,9 @@
 IF(PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "condvar")
   TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FUTEX=0)
   TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_GCD=0)
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_EVENT=0)
 ELSEIF(PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "futex")
   TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FUTEX=1)
   TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_GCD=0)
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_EVENT=0)
-ELSEIF(PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "gcd")
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FUTEX=0)
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_GCD=1)
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_EVENT=0)
-ELSEIF(PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "event")
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FUTEX=0)
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_GCD=0)
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_EVENT=1)
 ELSEIF(NOT PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "default")
   MESSAGE(FATAL_ERROR "Unsupported synchronization primitive ${PTHREADPOOL_SYNC_PRIMITIVE}")
 ENDIF()
@@ -132,9 +146,6 @@
   TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FASTPATH=0)
 ENDIF()
 
-SET_TARGET_PROPERTIES(pthreadpool PROPERTIES
-  C_STANDARD 11
-  C_EXTENSIONS NO)
 TARGET_LINK_LIBRARIES(pthreadpool PUBLIC pthreadpool_interface)
 TARGET_INCLUDE_DIRECTORIES(pthreadpool PRIVATE src)
 IF(NOT CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
@@ -177,16 +188,17 @@
   ENDIF()
 
   ADD_EXECUTABLE(pthreadpool-test test/pthreadpool.cc)
-  SET_TARGET_PROPERTIES(pthreadpool-test PROPERTIES
-    CXX_STANDARD 11
-    CXX_EXTENSIONS NO)
   TARGET_LINK_LIBRARIES(pthreadpool-test pthreadpool gtest gtest_main)
   ADD_TEST(pthreadpool pthreadpool-test)
 
+  IF(PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "condvar" OR
+     PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "futex")
+    ADD_EXECUTABLE(pthreadpool-v2-test test/pthreadpool_v2.cc)
+    TARGET_LINK_LIBRARIES(pthreadpool-v2-test pthreadpool gtest gtest_main)
+    ADD_TEST(pthreadpool pthreadpool-v2-test)
+  ENDIF()
+
   ADD_EXECUTABLE(pthreadpool-cxx-test test/pthreadpool-cxx.cc)
-  SET_TARGET_PROPERTIES(pthreadpool-cxx-test PROPERTIES
-    CXX_STANDARD 11
-    CXX_EXTENSIONS NO)
   TARGET_LINK_LIBRARIES(pthreadpool-cxx-test pthreadpool gtest gtest_main)
   ADD_TEST(pthreadpool-cxx pthreadpool-cxx-test)
 ENDIF()
@@ -201,14 +213,8 @@
   ENDIF()
 
   ADD_EXECUTABLE(latency-bench bench/latency.cc)
-  SET_TARGET_PROPERTIES(latency-bench PROPERTIES
-    CXX_STANDARD 11
-    CXX_EXTENSIONS NO)
   TARGET_LINK_LIBRARIES(latency-bench pthreadpool benchmark)
 
   ADD_EXECUTABLE(throughput-bench bench/throughput.cc)
-  SET_TARGET_PROPERTIES(throughput-bench PROPERTIES
-    CXX_STANDARD 11
-    CXX_EXTENSIONS NO)
   TARGET_LINK_LIBRARIES(throughput-bench pthreadpool benchmark)
 ENDIF()

=== debian/changelog ===
pthreadpool (0.0~git20251020.0e6ca13-1) unstable; urgency=medium

  * Team upload.
  * d/watch: switch to version 5, use Google fork as upstream.
  * New upstream version 0.0~git20251020.0e6ca13.
  * d/copyright: update with latest author info.
  * d/patches: refresh existing patches.
  * d/symbols: add new symbols for libpthreadpool0.
  * d/rules: use ninja as cmake backend.
  * d/control:
    + bump std-ver to 4.7.2 (no changes required).
    + change homepage to google fork.
    + mark Multi-Arch: same for dev package, use correct section name.

 -- Shengqi Chen <harry@debian.org>  Sat, 25 Oct 2025 16:49:32 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: pthreadpool
-Section: libdevel
-Homepage: https://github.com/Maratyszcza/pthreadpool
+Section: libs
+Homepage: https://github.com/google/pthreadpool
 Priority: optional
-Standards-Version: 4.7.0.1
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/deeplearning-team/pthreadpool.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/pthreadpool
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -10,13 +10,16 @@
 Build-Depends: cmake,
                debhelper-compat (= 13),
                googletest,
+               ninja-build,
                libbenchmark-dev,
                libcpuinfo-dev,
                libfxdiv-dev
 Rules-Requires-Root: no
 
 Package: libpthreadpool-dev
+Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: libpthreadpool0 (= ${binary:Version}), ${misc:Depends}
 Description: pthread-based thread pool for C/C++ (development)
  pthreadpool is a portable and efficient thread pool implementation. It provides
@@ -26,6 +29,7 @@
  This package contains the development files.
 
 Package: libpthreadpool0
+Section: libs
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- -DGOOGLETEST_SOURCE_DIR=/usr/src/googletest -DPTHREADPOOL_LIBRARY_TYPE=shared

=== debian/watch ===
Version: 5
Source: https://github.com/google/pthreadpool
Mode: git
Pgpmode: none
Matching-Pattern: HEAD
